function CADLIVE_DispCumulFreqQMPS(QMPS, tag)

figure;
hold on
%colormapő64Ȃ̂ŁAOt\͍ő64ƂB

%\vf̐
ntar=length(tag);
%evf̐Fݒ
cmap = colormap('Lines');
for i=1:ntar
    c(i,:) = cmap(i,:);
end

[nQMPS nY] = size(QMPS);
cumul(1)=1/nQMPS;
for j=2:nQMPS
    cumul(j)=cumul(j-1)+1/nQMPS;
end


for i=1:ntar
    QMPS_sort=sort(QMPS(:,i));
    plot(QMPS_sort,cumul,'o-','Color',c(i,:));
end
legend(tag,'Location','Best');
set(gca,'FontName','Arial');
xlabel('QMPS','FontName','Arial','FontSize',14);
ylabel('Cumulative Frequency','FontName','Arial','FontSize',14);
ylim([0 1.01]);
hold off


