function CADLIVE_DispHistCumulFreqQMPS(QMPS, tag, nbin, lb, ub)
% QMPS:  Data matrix whose each column shows each data set.
% tag:  The each tag name.
% nbin:  The number of classes.
% lb: Lower bound of the histograms. 
% ub: Upper bound of the histograms. 

figure;
hold on
%colormapő64Ȃ̂ŁAOt\͍ő64ƂB

%\vf̐
ntar=length(tag);
%evf̐Fݒ
cmap = colormap('Lines');
for i=1:ntar
    c(i,:) = cmap(i,:);
end

[nQMPS nY] = size(QMPS);

[C F] = CADLIVE_mycumulhist(QMPS,nbin,lb,ub);

%{
cumul(1)=1/nQMPS;
for j=2:nQMPS
    cumul(j)=cumul(j-1)+1/nQMPS;
end
%}

C2=C;F2=F;
C(1)=0;C(2:nbin+1)=C2;
F(1,:)=0;F(2:nbin+1,:)=F2;

for i=1:ntar
    %QMPS_sort=sort(QMPS(:,i));
    %plot(QMPS_sort,cumul,'o-','Color',c(i,:));
    
    plot(C,F(:,i)'./nQMPS,'-o','Color',c(i,:));
end


legend(tag,'Location','Best');
set(gca,'FontName','Arial');
xlabel('QMPS','FontName','Arial','FontSize',14);
ylabel('Cumulative Frequency','FontName','Arial','FontSize',14);
ylim([0 1.01]);
hold off


