function CADLIVE_DispHistFreqQMPS(QMPS, tag)

%\vf̐
ntar=length(tag);
[nQMPS nY] = size(QMPS);

% X^[WFX̌
nbin = round(1 + log2(nQMPS));

minimum = min(min(QMPS));
maximum = max(max(QMPS));
step = (maximum-minimum)/(nbin-1);


[bin count] = CADLIVE_myhist(QMPS,nbin,minimum,maximum);


figure;
bar(bin,count);

legend(tag,'Location','Best');
set(gca,'FontName','Arial');
xlabel('QMPS','FontName','Arial','FontSize',14);
ylabel('Frequency','FontName','Arial','FontSize',14);
ylim([0 max(max(count))*1.01]);
hold off


