classdef CADLIVE_SelectChemO
    properties(Constant)
        Name = 'CADLIVE_SelectChemO';
        CMA = 'CMA';
        TPP_STEADYSTATE_1 = 'TPP_STEADYSTATE_1';
        TPP_STEADYSTATE_2 = 'TPP_STEADYSTATE_2';
        TPP_RAPID = 'TPP_RAPID';
        TPP = 'TPP';
        GMA = 'GMA';
        MM = 'MM';
        SAME_AS_GENE_PROTEIN = 'SAME_AS_GENE-PROTEIN';
    end
    properties
        ChemPath;       % wf[^t@C
        GenProtein;     % Gene-Protein-layer
        ChemGenProtein; % Gene-Protein-layer̉w
        Metabolic;      % Metabolic-layer
        ChemMetabolic;  % Metabolic-layer̉w
        DaePath;        % DAEt@C
        UsagePath;      % Usaset@C
    end
    
    methods
        function obj = CADLIVE_SelectChemO(chemPath, genProtein, chemGenProtein, metabolic, chemMetabolic, daePath, usagePath)
            obj.ChemPath = chemPath;
            obj.GenProtein = genProtein;
            obj.ChemGenProtein = chemGenProtein;
            obj.Metabolic = metabolic;
            obj.ChemMetabolic = chemMetabolic;
            obj.DaePath = daePath;
            obj.UsagePath = usagePath;
        end
   end
end
    