function [solution searchParam info flag] = CADLIVE_myTPScommand(term_n_solution, AE, AEC, RRIG,...
    				n_generation, n_population, n_children, searchType, alpha, beta)

info.term_n_solution = term_n_solution;
info.AE = AE;
info.AEC = AEC;
info.RRIG = RRIG;
info.n_generation = n_generation;
info.n_population = n_population;
info.n_children = n_children;
info.searchType = searchType;
info.alpha = alpha;
info.beta = beta;

info.type='TPS';
%TPS̏
info = CADLIVE_writeTPSinfo( 0, info, 0, 0, 0);

%TPSs
%fprintf('TPS_start.\n');
tic;
[solution, searchParam, info, flag] = CADLIVE_myTPS(info);
%solution.gene, solution.fitness
%searchParam.varname, searchParam.index
time=toc;
%fprintf('TPS_finish.\n');

if flag == -1
    error('TPS error.');
end

%write the TPS information
CADLIVE_writeTPSinfo( time, info, solution, searchParam, 1);


