function [ result, a, indx] = CADLIVE_nr_ludcmp( a, n )
%NR_LUDCMP LU
% nr_lu.cppnr_ludcmp֐̂܂܈ڐA
% RgȂ̂́AȂ

    vv = zeros(1,n);
    indx = zeros(1, n);
    for i=1:1:n
        big = 0.0;
        for j=1:1:n
            temp = abs( a(i, j) );
            if temp > big
                big = temp;
            end
        end
        if big == 0.0
            result = false;
            return;
        end
        vv(i) = 1.0 / big;
    end

    imax = 0;
    for j=1:1:n 
        for i=1:1:(j-1)
            sum = a(i,j);
            for k=1:1:(i-1)
                sum = sum - a(i,k) * a(k,j);
            end
            a(i,j) = sum;
        end
        
        big=0.0;
        for i=j:1:n
            sum = a(i,j);
            for k=1:1:(j-1)
                sum = sum - a(i,k)*a(k,j);
            end
            a(i,j) = sum;
            dum = vv(i) * abs(sum);
            if dum >= big
                big = dum;
                imax = i;
            end
        end
        
        if j ~= imax
            for k=1:1:n
                dum = a(imax,k);
                a(imax,k) = a(j,k);
                a(j,k) = dum;
            end
            vv(imax) = vv(j);
        end
        
        indx(j) = imax;
        if a(j,j) == 0.0
            a(j,j) = 1.0e-20;   % TINY
        end
        if j ~= n
            dum = 1.0 / a(j,j);
            for i=j+1:1:n
                a(i,j) = a(i,j) * dum;
            end
        end
    end
    
    result = true;
    return;
end

