classdef CADLIVE_ode15s < CADLIVE_ode
    %CADLIVE_ODE15S ̃NX̊TvɋLq
    %   ڍאɋLq
    
    methods
        function obj = CADLIVE_ode15s(ctrl, param, paramT, paramP)
            % RXgN^
            obj = obj@CADLIVE_ode(ctrl, param, paramT, paramP);
        end
    end
    
    methods(Access=protected)
        function [options] = ndf_init(obj)
            options = odeset( ...
                'RelTol', obj.CONTROL_DATA.NDF_RTOL ...             % ftHg
                , 'AbsTol', obj.CONTROL_DATA.NDF_ATOL ...           % ftHg
                , 'NormControl', 'off' ...              % ftHg
                , 'MStateDependence', 'weak' ...        % ftHg
                , 'MassSingular', 'maybe' ...           % ftHg
                , 'MaxOrder', 5 ...                     % ftHg
                , 'BDF', 'off' ...                      % ftHg
                , 'InitialStep', obj.CONTROL_DATA.DELTA_T ... 
                , 'Mass', obj.CONTROL_DATA.MASS  ... 
                , 'Events', @CADLIVE_MyEvent ...
                );
        end
        
        function [lenEvents, evnt_t, event_t_len] = getEventInterval(obj, evts_)
            evnt_t = 0;
            lenEvents = length(evts_)-1;
            event_t_len = 0;
            for ie=1:1:lenEvents
                % o͎̐ݒB
                % o͊Ԋuwidt_save=0jꍇ́A
                % SvZ|CgóB<= t0num[ie]=2 Ǝw肷B
                t_num = 2;
                if obj.CONTROL_DATA.DELTA_M > 0
                    div = ( ...
                        evts_(ie + 1).Events(1).time - evts_(ie).Events(1).time ...
                        ) ...
                        / obj.CONTROL_DATA.DELTA_M;
                    idiv = int32(div);
                    mod = div - double(idiv);
                    
                    % I_ߖTi10ȓj̓_͏B
                    if (idiv ~= 0)
                        if (mod < 0.1)
                            idiv = idiv - 1;
                        end
                    end
                    t_num = t_num + idiv;
                end
                
                % o͎ݒ
                evnt_t(ie, 1) = evts_(ie).Events(1).time;
                for i=2:1:(t_num-1)
                    evnt_t(ie, i) = evnt_t(ie,i - 1) + obj.CONTROL_DATA.DELTA_M;
                end
        		evnt_t(ie, t_num) = evts_(ie + 1).Events(1).time;
                event_t_len(ie) = t_num;
            end
        end
        
        function [t_time, t_y] = executeSolver(obj, time_step_exec, y, options)
            global Parameter;
            
            param_bk = Parameter;
            Parameter = obj.Param;
            [t_time, t_y]=ode15s(@CADLIVE_odefunc,time_step_exec, y, options);
            Parameter = param_bk;
        end
        
        function [result, y, y_pre] = executeSolveAlgebraicEq(obj, y, y_pre, hasParamEvents)
            result = true;
            % 2w̏ꍇ
            if obj.CONTROL_DATA.N_ALGEBR ~= 0
                % p[^ύXĂ
                % QߓIɒlςĘAB
                if hasParamEvents == true
                    [result, y_pre] = obj.CheckNRparam(y_pre);
                    if result == false
                        return;
                    end
                    % 㐔̉𔽉f
                    y = y_pre;
                end

                % A𓊋@IɉA
                % ȂΑQߏɂĉB
                [result, y, y_pre] = obj.SolveAlgebraicEq(y, y_pre);
                if result == false
                    return;
                end
            end
        end
        
        function [y, t_y, res_time, res_y, y_pre] = outputResponse(obj, y, t_time, t_y, is_yadding, y_add, res_time, res_y)
            % Y_ADD ꍇAI_̂ݏóB
            lenY = length(y);
            lenT = length(t_time);
            stI = 1;
            if is_yadding == true
                stI = lenT;
            end

			%corrected by inoue
            %idxIt = length(res_time)+1;
            if length(res_time) == 0
               idxIt = 1;
            else
               idxIt = length(res_time);
            end
            %%%%%%%%%%%%%%%%%%%%%%%%%%%
            for it=stI:1:lenT

                % Ԃo
                res_time(idxIt,1) = t_time(it);
                for i=1:1:lenY
                    % Y_ADD s
                    if is_yadding == true && i >= obj.CONTROL_DATA.N_ALGEBR
                        t_y(it,i) = t_y(it,i) + (y_add(i + 1) * (t_time(it) - t_time(0)));
                    end

                    % ɂȂ[jOB
                    % ܂̂Ƃ뉽Ȃ

                    % ʂo
                    res_y(idxIt, i) = t_y(it, i) / obj.CONTROL_DATA.G_VALUE;

                    % 񏉊l̐ݒBȉI_j
                    if it == lenT
                        y(i) = t_y(it,i);
                        y_pre(i) = y(i);
                    end
                end
                idxIt = idxIt + 1;
            end
        end
    end
    
    
end

