function populations = CADLIVE_sortPopulations(populations)

n_populations = length(populations);
n_gene = length(populations(1).gene);

temp = zeros(n_populations,n_gene+1);
for i = 1:n_populations
    temp(i,:) = [populations(i).gene populations(i).fitness];
end
temp = sortrows(temp,n_gene+1);
for i = 1:n_populations
    for j = 1:n_gene
        populations(i).gene(j) = temp(i,j);
    end
    populations(i).fitness = temp(i,n_gene+1);
end
