classdef CADLIVE_Messages
    %CADLIVE_MESSAGES bZ[W`
    
    properties(Constant)
        ERROR = 'Error';
        CONFIRM = 'Confirm';
        YES = 'Yes';
        NO = 'No';
        SAVE_CSV = 'Save (CSV)';
        SAVE_MATLAB = 'Save (MATLAB)';
        
        % wf[^t@CIĂ
        SELECT_CHEM_EQU = 'Please select a data file chemical equation';
        % wf[^t@C͂ĂB
        INPUT_CHEM_FILE = 'Please enter a chemical reaction data file.';
        % wf[^t@C̉͂Ɏs܂B
        FAILE_PARSE_CHEM = 'Failed to parse the data file chemical equation.';
        % wf[^t@CǂݍłB
        READ_CHEM_FILE = 'Please read the data file chemical equation.';
        % }[Wp^t@CIĂB
        SELECT_MERGE_FILE = 'Please select the parameter file to be merged.';
        % p^t@C̃}[W܂A낵łH
        CONFIRM_MERGE = 'The merging of the parameter file, you sure?';
        % p^t@C̉͂Ɏs܂B
        FAILE_PARSE_PARAM = 'Failed to parse the parameter file.';
        % p^t@C̃}[W܂B
        CONFIRM_MERGE_END = 'Merge of the parameter file has been successfully.';
        % V~[Vs܂A낵łH
        CONFIRM_SIM = 'To run the simulation, you sure?';
        % o͂܂B
        COMPLETE_OUTPUT = 'Output has been completed.';
        % XNvgԂɖ߂܂A낵łH
        CONFIRM_SCRIPT_RESET = 'The script file back to its initial state, Are you sure?';
        
        % V~[VɎs܂B
        FAILE_SIMULATION = 'Failed to simulation.';
        
        ERR_RKEPS = 'Relative is negative.';
        ERR_NDF_RTOL= 'Relative is negative.';
        ERR_NDF_ATOL= 'Absolute is negative.';
        ERR_STARTTIME = 'Start time is negative.';
        ERR_ENDTIME = 'End time is empty or ''0''.';
        ERR_STEPTIME = 'Time step-size is empty or ''0''.';
        ERR_MONTIME = 'Monitoring interval is empty or ''0''.';
        ERR_MON_STEPTIME = 'Monitoring interval < time step-size.';
        ERR_MAX_TRI_TIME = 'Maximum trial times is negative.';
        ERR_TOL_F = 'Tolerance for convergence of functions is negative.';
        ERR_TOL_V = 'Tolerance for convergence of variables is negative.';
        ERR_CHG_RATIO = 'Ratio of changing parameters is negative.';
        ERR_CALC_SENSE = 'Change width for calc. sensitivity(STD) is negative.';
        ERR_GVALUE = 'G-value is negative.';
        ERR_YDEFVALUE = 'Y default value is negative.';
    end
    
    
end

