function [info solution] = CADLIVE_TPSinfoAlign(TPScondition, solution, n_trial, n_rs, n_solution, n_coarse_solution, ...
												n_solution_obtained_in_GA, n_solution_obtained_in_first_generation, ...
												n_evaluation)

info.n_trial = n_trial;
info.n_rs = n_rs;
info.n_solution = n_solution;
info.n_coarse_solution = n_coarse_solution;
info.n_solution_obtained_in_GA = n_solution_obtained_in_GA;
info.n_solution_obtained_in_first_generation = n_solution_obtained_in_first_generation;
info.n_evaluation = n_evaluation;

info.term_n_solution = TPScondition.term_n_solution;
info.AE = TPScondition.AE;
info.AEC = TPScondition.AEC;
info.RRIG = TPScondition.RRIG;
info.n_generation = TPScondition.n_generation;
info.n_population = TPScondition.n_population;
info.n_children = TPScondition.n_children;
info.searchType = TPScondition.searchType;
info.alpha = TPScondition.alpha;
info.beta = TPScondition.beta;

%sort solution

for i=1:n_solution
	temp(i) = solution(i).fitness;
end

[temp ind] = sort(temp);

for i=1:n_solution
	solution2(i) = solution(ind(i));
end

solution=solution2;
clear solution2 temp

