function population = CADLIVE_getNewChild(p1, p2, p3, searchParam, info)
% info.searchType, info.alpha, info.beta
% Handler of UNDX function
% Checking wheather children are in search region 

maxitr = 100;
flg = 1;

for i = 1:maxitr
    population = CADLIVE_UNDX(p1, p2, p3, info.alpha, info.beta);
    if 0 <= min(population.gene) && max(population.gene) <= 1
        flg = 0;
        break;
    end
end

if flg == 1
    for i = 1:length(population.gene)
        if 1 < population.gene(i)
            population.gene(i) = 1;
        elseif population.gene(i) < 0
            population.gene(i) = 0;
        end
    end
end

population = CADLIVE_evaluation(population, searchParam, info);
