function [ b ] = CADLIVE_nr_lubksb( a, n, indx, b )
%CADLIVE_NR_LUBKSB LUޑ
%  LUޑ(nr_lu.cppnr_lubksb֐ڐA)
%  n ̐^̑g A*x = b B
%  ͂s a[1..n][1..n] ́Aludcmp() Ԃ A LUłB
%  ͂xNg b[1..n] ́AEӂ̃xNgłB
%  {[`́Aa, n, indx Ȃ̂ŁA
%  Eӂ b ςĂJԂgB
%  b ̍ŏɁA[ł\lĂ̂ŁA
%  Iɋts񂪋߂B

	 % ii ȂÁAb ̍ŏ̃[łȂvf̓YłB
	 % sɖ߂Ȃ玮̑OisB
	 % A*x = (L*U)*x = L*(U*x) = b
	 % L*y = b, U*x = y
	 % y[1] = b[1] / L[1,1]
	 % y[i] = {b[i] - Sigma(j=1,i-1)(L[i,j]*y[j])} / L[i,i]
	 % i = 2, 3, ..., n; L[i,i] = 1
     ii = 0;
    for i=1:1:n
        ip = indx(i);
        sum = b(ip);
        b(ip) = b(i);
        if ii ~= 0 
            for j=ii:1:(i-1)
                sum = sum - a(i,j) * b(j);
            end
        elseif sum ~= 0
            % [vfɏoB
            % ȍ~͏̃[vŘa߂B
            ii = i;
        end
        b(i) = sum;
    end

    % ̌ޑsB
    % x[n] = y[n] / U[n,n]
    % x[i] = {y[i] - Sigma(j=i+1,n)(U[i,j] * x[j])} / U[i,i]
    % i = n-1, n-2, ..., 1
    for i=n:-1:1
        sum = b(i);
        for j=i+1:1:n
            sum = sum - a(i,j) * b(j);
        end
        b(i) = sum / a(i,i);
    end
end

