function [ daePath, usagePath ] = CADLIVE_parsedae( in_file_name, g_option, m_option )
% parsedae -Nin_file_path -Uxxx -Dxxx s
%   sɍۂāAL̊ϐݒ肳Ă邱
%   SANAC_HOME, XERCES_HOME
    daePath = '';
    usagePath = '';

    % ϐ̐ݒ
    CADLIVE_setenv();
    
    SANAC_HOME = getenv('SANAC_HOME');
    dtdPath = strcat(SANAC_HOME, '\sanac.dtd');
    cmdPath = strcat(SANAC_HOME, '\parsedae');
    
    cmd = strcat( cmdPath, ' -N', in_file_name, ' -UMathUsage.txt -DMathDAE.txt');
    cmd = strcat(cmd, ' -g', g_option);
    cmd = strcat(cmd, ' -m', m_option);

    copyfile( dtdPath, '.\' );
    [status] = dos(cmd);

    if status == 0 
        daePath = 'MathDAE.txt';
        usagePath = 'MathUsage.txt';
    end
end

