function solution = CADLIVE_saveTPSResults(solution, info, population0, searchParam, type)

searchParam = CADLIVE_decodeGene2Variable(population0, searchParam, info);
solution(info.n_solution).fitness = population0.fitness;
for z=1:info.n_gene
	solution(info.n_solution).paramValue(z) = searchParam(z).newValue;
end
solution(info.n_solution).type = type;

fprintf('%s:fitness=%e\n', type, population0.fitness);

%write the TPS result into mat file
save(info.tpsFile,'searchParam','solution','info');
