function info = CADLIVE_writeGAinfo( time, info, step)


if step == 0
	%Preparation for result
	%œKꂽp^㏑Ȃ悤Ƀt@CύX
	f=0;
	while 1
		if f==0
			optFile = 'OptimizedParameter.mat';
		else
			optFile = sprintf('OptimizedParameter_%d.mat',f);
		end
	
		if exist(optFile, 'file')
			f=f+1;
		else
			info.optFile = optFile;
			break;
		end
	end

	%Parametert@C̏o
	if exist('CADLIVE_OptParam.m','file')==0
		fo=fopen('CADLIVE_OptParam.m','w');
		fprintf(fo,'function [param, event]=CADLIVE_param()\n');
		fprintf(fo,'load OptimizedParameter.mat;\n');
		fclose(fo);
	end
	
	%Initial condition
	fo = fopen('GAResultInfo.dat','w');

	fprintf(fo,'$$Conditions\n');
	fprintf(fo,'Number of maximum generation: %d\n', info.maxGeneration);
	fprintf(fo,'Termination condition: %d\n', info.allowable_error);
	fprintf(fo,'Number of population: %d\n', info.n_population);
	fprintf(fo,'Number of children generated: %d\n', info.n_children);
	fprintf(fo,'Search type: %s\n', char(info.searchType));
	fprintf(fo,'Alpha: %f\n', info.alpha);
	fprintf(fo,'Beta: %f\n', info.beta);
	fprintf(fo,'\n');
	
	fclose(fo);
elseif step == 1
	%Result
	fo = fopen('GAResultInfo.dat','a');
	
	fprintf(fo,'Calculation time: %d hour %d min %d sec\n',floor(time/(60*60)),floor(mod(time/60,60)),floor(mod(time,60)));
	fprintf(fo,'Number of generation calculated: %d\n', info.n_generation);
	fprintf(fo,'Best fitness: %e\n', info.fitness);
	
	fclose(fo);
end